'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _service = require('./service');

var _service2 = _interopRequireDefault(_service);

//parser for photo
function binaryParser(res, callback) {
  res.setEncoding('binary');
  res.text = '';
  res.on('data', function (chunk) {
    res.text += chunk;
  });
  res.on('end', function () {
    return callback(null, new Buffer(res.text, 'binary'));
  });
}

var Users = (function (_Service) {
  _inherits(Users, _Service);

  function Users(apiUrl, options) {
    _classCallCheck(this, Users);

    _get(Object.getPrototypeOf(Users.prototype), 'constructor', this).call(this, apiUrl, options);
    this.path = '/users';
  }

  _createClass(Users, [{
    key: 'login',
    value: function login(email, password, callback) {
      var agent = this.request.post('' + this.apiUrl + this.path + '/login').set(this.generateHeaders()).auth(email, password);
      return this.handleSpecialCall(agent, callback);
    }
  }, {
    key: 'loginWithSlack',
    value: function loginWithSlack(handle, pin, callback) {
      var agent = this.request.post('' + this.apiUrl + this.path + '/loginwithslack').set(this.generateHeaders()).auth(handle, pin);
      return this.handleSpecialCall(agent, callback);
    }
  }, {
    key: 'getUsers',
    value: function getUsers(user, callback) {
      return this.get(user, this.path, callback);
    }
  }, {
    key: 'getUserByEmail',
    value: function getUserByEmail(user, email, callback) {
      return this.get(user, this.path + '/' + email, callback);
    }
  }, {
    key: 'createUser',
    value: function createUser(user, properties, callback) {
      return this.post(user, this.path, properties, callback);
    }
  }, {
    key: 'createNewUser',
    value: function createNewUser(properties, callback) {
      var agent = this.request.post('' + this.apiUrl + this.path + '/new').set(this.generateHeaders()).send(properties);
      return this.handleSpecialCall(agent, callback);
    }
  }, {
    key: 'updateUser',
    value: function updateUser(user, email, properties, callback) {
      return this.put(user, this.path + '/' + email, properties, callback);
    }
  }, {
    key: 'activateUser',
    value: function activateUser(user, email, callback) {
      return this.put(user, this.path + '/' + email + '/active/true', {}, callback);
    }
  }, {
    key: 'deactivateUser',
    value: function deactivateUser(user, email, callback) {
      return this.put(user, this.path + '/' + email + '/active/false', {}, callback);
    }
  }, {
    key: 'deleteUser',
    value: function deleteUser(user, email, callback) {
      return this.del(user, this.path + '/' + email, callback);
    }
  }, {
    key: 'getServices',
    value: function getServices(user, email, callback) {
      return this.get(user, this.path + '/' + email + '/service', callback);
    }
  }, {
    key: 'getServiceByName',
    value: function getServiceByName(user, email, serviceName, callback) {
      return this.get(user, this.path + '/' + email + '/service/' + serviceName, callback);
    }
  }, {
    key: 'createService',
    value: function createService(user, email, serviceProperties, callback) {
      return this.post(user, this.path + '/' + email + '/service', serviceProperties, callback);
    }
  }, {
    key: 'deleteService',
    value: function deleteService(user, email, serviceName, callback) {
      return this.del(user, this.path + '/' + email + '/service/' + serviceName, callback);
    }
  }, {
    key: 'getPhoto',
    value: function getPhoto(user, email, callback) {
      var agent = this.request.get('' + this.apiUrl + this.path + '/' + email + '/photo').set(this.generateHeaders(user, { 'Accept': 'application/octet-stream' })).buffer(true).parse(binaryParser);
      if (this.returnPromise) {
        return new Promise(function (resolve, reject) {
          agent.end(function (err, res) {
            if (err) {
              reject(err);
            } else {
              resolve(res.body);
            }
          });
        });
      } else {
        agent.end(function (err, res) {
          if (err) {
            callback(err);
          } else {
            callback(null, res.body);
          }
        });
      }
    }
  }, {
    key: 'setPhoto',
    value: function setPhoto(user, email, filePath, callback) {
      var agent = this.request.put('' + this.apiUrl + this.path + '/' + email + '/photo').set(this.generateHeaders(user, { 'Content-Type': 'multipart/form-data' })).attach('photo', filePath);
      return this.handleSpecialCall(agent, callback);
    }
  }]);

  return Users;
})(_service2['default']);

exports['default'] = Users;
module.exports = exports['default'];